/**
 *  PSPad Last modified script
 *  (c) by Claude CHAUVET 26 Feb 2007
 *
 */

var module_name = "LastModifiedJS";
var module_ver = "0.01";


// Created by Claude CHAUVET 26 Feb 2007
// wkz3w59<at>free<dot>fr

//---------------------------------------------------------
// generates a list of all files in a project sorted in reverse order by 
//    last modification date
// useful to retrieve the last changes you made and what files really need
//    to be uploaded - without forgetting any
//---------------------------------------------------------

function Init() {
  addMenuItem ("Last modified files","","TriProjet");
}

//---------------------------------------------------------

function TriProjet () {

  windowName = "_chronologie_"; // feel free to change this name it if you already use it   

  var obj1 = newEditor();
  var nomFichier;
  var fichier;
  var dateFichier;
  var arNom = new Array();
  var kk;

  try { obj1.assignEditorByName(windowName);}   // try to open previously created window
  catch(e) {  obj1.newFile(windowName); }       // else create a new one

  obj1.text("");
  obj1.activate();                              // force focus

  var fso = new ActiveXObject("Scripting.FileSystemObject");

// build list   
  kk=0;
  for (var k=0; k < projectFilesCount(); k++) {
    nomfichier=projectFiles(k);
    if (fso.fileexists(nomfichier))  {
      fichier = fso.GetFile(nomfichier);
      dateFichier = new Date( fichier.DateLastModified);
      arNom[kk++]= dateFichier.getFullYear() +"/" 
                     + deuxChiffres ((dateFichier.getMonth()+1)) +"/" 
                     + deuxChiffres (dateFichier.getDate()) + " "
                     + deuxChiffres (dateFichier.getHours()) + ":"
                     + deuxChiffres (dateFichier.getMinutes())+" "
                     + nomfichier;
    } // if file exists
  } // for k

// sort list 
  arNom.sort(ordreInverse);

// and print it to window
  for (var k=0; k < arNom.length; k++) {
    obj1.appendText(arNom[k]+"\n");
  } // for k
}

//---------------------------------------------------------
// for month, date .. formatting

function deuxChiffres (valeur) {
  var str = "00"+ valeur.toString();
  return str.substr(str.length-2); 
}

//---------------------------------------------------------
// for reverse order sorting

function ordreInverse (first,second) {
  if (first<second) return 1;
  if (first>second) return -1;
  return 0;
}
